
/*

	XDSP example - basics
	Demonstrates initialization, buffer management and short->float conversion


*/

#include "stdafx.h"
#include "../../include/xdsp.h"


int main(int argc, char* argv[])
{
	// initialize XDSP with for use with given samplerate
	xdsp.Init(44100, (1.0 / (1 << 20)));
	
	if (SSESupported)
		printf("SSE detected\n");

	dword const bufsize = 256;

	// allocate float buffer of 256 samples
	float *buffer = xdsp.NewBuffer(bufsize);

	// allocate short buffer of 256 samples
	short *shortbuffer = xdsp.NewShortBuffer(bufsize);
	
	// generate white noise to the short buffer
	for (dword i = 0; i < bufsize; i++)
		shortbuffer[i] = rand() - (RAND_MAX / 2);

	// convert shorts to floats
	xdsp.Copy_V_VS(buffer, shortbuffer, bufsize);

	// free short buffer
	xdsp.DeleteShortBuffer(shortbuffer);
	
	// free buffer
	xdsp.DeleteBuffer(buffer);

	return 0;
}
