
#ifndef __XDSP_AUDIO_GRAPH_NODE_H
#define __XDSP_AUDIO_GRAPH_NODE_H

#include "XDSPInterface.h"

#pragma pointers_to_members(full_generality, multiple_inheritance)
class CXAudioGraphCallback {};
typedef void (CXAudioGraphCallback::*AUDIO_GRAPH_CALLBACK_FUNC)(float const * const * const inputs, float ** const outputs, dword const numsamples);

class CXAudioGraphNodeImpl;
class CXAudioGraphNode : public CXObject
{
public:
	CXAudioGraphNode();
	virtual ~CXAudioGraphNode();
	
	bool AddInputPort(dword const i);
	bool RemoveInputPort(dword const i);
	
	bool AddOutputPort(dword const i);
	bool RemoveOutputPort(dword const i);
	
	friend bool Connect(CXAudioGraphNode *psrc, dword const srcport, CXAudioGraphNode *pdst, dword const dstport);
	friend bool Disconnect(CXAudioGraphNode *psrc, dword const srcport, CXAudioGraphNode *pdst, dword const dstport);
	
	void SetCallback(CXAudioGraphCallback *pcb, AUDIO_GRAPH_CALLBACK_FUNC pfunc);

private:
	friend class CXAudioGraphImpl;
	CXAudioGraphNodeImpl *pImpl;

	
};

#endif 
