
// Copyright 2002-2003 Oskari Tammelin (ot@iki.fi)


#ifndef __XDSP_H
#define __XDSP_H

#include "XDSPInterface.h"

#define CC __fastcall

extern CXDSPInterface xdsp;				// use only with 16 byte aligned buffers
extern CXDSPInterface xdsp_noalign;

extern bool const MMXSupported;
extern bool const SSESupported;
extern bool const SSE2Supported;
extern bool const _3DNOWSupported;

extern void CC EnableSSE(bool enable);

#define ASSERT_XDSP_ALIGNMENT(x) assert(((dword)(x) & 15) == 0);

// extras

// fast pow(2, x) approximation, good for audio stuff
// the maximum error is less than 0.002 cents or 0.000093 percent
extern float CC XPow2(float const x);		 

// fast and accurate db -> amplitude
__forceinline float XDBToAmplitude(float const x)
{
	return XPow2((float)(x * 0.16609640474436811739));
}

extern char const *GetXDSPVersionString();

#undef CC

#endif