
#ifndef __AUDIO_GRAPH_NODE_IMPL_H
#define __AUDIO_GRAPH_NODE_IMPL_H

#include "AudioGraphPort.h"
#include "AGInstructionBuffer.h"

typedef std::vector<CAudioGraphPort *> CAudioGraphPortPtrVector;

class CXAudioGraphImpl;

class CXAudioGraphNodeImpl 
{
public:
	CXAudioGraphNodeImpl();
	virtual ~CXAudioGraphNodeImpl();

	bool AddInputPort(dword const i);
	bool RemoveInputPort(dword const i);
	
	bool AddOutputPort(dword const i);
	bool RemoveOutputPort(dword const i);
	
	void SetCallback(CXAudioGraphCallback *pcb, AUDIO_GRAPH_CALLBACK_FUNC pfunc)
	{
		pCB = pcb;
		pCBFunc = pfunc;
	}

	void Compile();

	bool CycleTest();


public:
	bool AddPort(CAudioGraphPortPtrVector &v, dword const i);
	bool RemovePort(CAudioGraphPortPtrVector &v, dword const i);

	CAudioGraphPort *GetInputPort(dword const i) const
	{
		if (i >= InputPorts.size())
			return NULL;

		return InputPorts[i];
	}

	CAudioGraphPort *GetOutputPort(dword const i) const
	{
		if (i >= OutputPorts.size())
			return NULL;
		
		return OutputPorts[i];
	}
	 
public:
	friend class CXAudioGraphImpl;

	void SetGraph(CXAudioGraphImpl *pg) { pGraph = pg; }
	CXAudioGraphImpl *GetGraph() const { return pGraph; }
	
private:
	CAudioGraphPortPtrVector InputPorts;
	CAudioGraphPortPtrVector OutputPorts;
	CXAudioGraphImpl *pGraph;

	CXAudioGraphCallback *pCB;
	AUDIO_GRAPH_CALLBACK_FUNC pCBFunc;

public:
	bool CycleTestFlag;

	bool Processed;

};

#endif 
