// AudioGraphPort.cpp: implementation of the CAudioGraphPort class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AudioGraphNodeImpl.h"
#include "AudioGraphPort.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CAudioGraphPort::CAudioGraphPort(CXAudioGraphNodeImpl *pn)
: pNode(pn), OutputCount(0), BufferIndex(-1)
{

}

CAudioGraphPort::~CAudioGraphPort()
{
	for (CAudioGraphPortPtrList::iterator i = Connections.begin(); i != Connections.end(); i++)
	{
		if (*i != NULL)
		{
			assert((*i)->HasConnection(this));
			(*i)->RemoveConnection(this);
		}
	}


}

bool CAudioGraphPort::HasConnection(CAudioGraphPort const *pn)
{
	for (CAudioGraphPortPtrList::iterator i = Connections.begin(); i != Connections.end(); i++)
	{
		if (*i == pn)
			return true;
	}

	return false;
}

bool CAudioGraphPort::RemoveConnection(CAudioGraphPort const *pn)
{
	for (CAudioGraphPortPtrList::iterator i = Connections.begin(); i != Connections.end(); i++)
	{
		if (*i == pn)
		{
			Connections.erase(i);
			return true;
		}
	}
	
	return false;
}

