#include "stdafx.h"
#include "dspinternal.h"
#include <malloc.h>

extern CXDSPInterface xdsp;

class CXOscillatorArrayImp : public CXOscillatorArray
{
public:
	virtual ~CXOscillatorArrayImp()
	{
		_aligned_free(Amplitudes);
	}

public:
	dword numOscs;
	dword numReqOscs;
	float *TempBuffer;

	float *CosPhase;
	float *SinPhase;
	float *CosFreq;
	float *SinFreq;
};

//*XDSP*
static void OscArraySetPhases(CXOscillatorArray *_poa, float const *phases)
{
	CXOscillatorArrayImp *poa = (CXOscillatorArrayImp *)_poa;

	if (phases == NULL)
	{
		xdsp.Clear_V(poa->SinPhase, poa->numOscs);
		xdsp.Copy_V_S(poa->CosPhase, poa->numOscs, 1.0f);
	}
	else
	{
		xdsp.SinCos_V2N_V(poa->SinPhase, poa->CosPhase, phases, poa->numReqOscs);
	}
	
}



//*XDSP*
static CXOscillatorArray *OscArrayCreate(dword const _numoscs, float *tempbuffer)
{
	if (_numoscs == 0 || tempbuffer == NULL)
		return NULL;

	CXOscillatorArrayImp *poa = new CXOscillatorArrayImp;

	poa->numReqOscs = _numoscs;
	poa->numOscs = (_numoscs+7) & ~7;
	poa->TempBuffer = tempbuffer;
	poa->Amplitudes = (float *)_aligned_malloc(6 * poa->numOscs * sizeof(float), 32);
	poa->AmplitudeDeltas = poa->Amplitudes + poa->numOscs;
	poa->CosPhase = poa->Amplitudes + 2 * poa->numOscs;
	poa->SinPhase= poa->Amplitudes + 3 * poa->numOscs;
	poa->CosFreq = poa->Amplitudes + 4 * poa->numOscs;
	poa->SinFreq = poa->Amplitudes + 5 * poa->numOscs;
	
	xdsp.Clear_V(poa->Amplitudes, 6 * poa->numOscs);
	
	OscArraySetPhases(poa, NULL);

	return poa;
}

//*XDSP*
static void OscArraySetFrequencies(CXOscillatorArray *_poa, float const *freqs)
{
	CXOscillatorArrayImp *poa = (CXOscillatorArrayImp *)_poa;
	xdsp.SinCos_V2N_V(poa->SinFreq, poa->CosFreq, freqs, poa->numReqOscs);

	for (dword i = 0; i < poa->numReqOscs; i++)
	{
		if (freqs[i] >= JXPI)
		{
			poa->SinFreq[i] = 0;
			poa->CosFreq[i] = 0;
			poa->SinPhase[i] = 0;
			poa->CosPhase[i] = 1;
		}
	}

}

        

//*XDSP*
static void OscArrayRun(CXOscillatorArray *_poa, float *pout, dword const n)
{
	CXOscillatorArrayImp *poa = (CXOscillatorArrayImp *)_poa;


}


#include "set/OscArrayFPU.set"