
#include "stdafx.h"
#include <malloc.h>
#include "XDSPInterface.h"
#include "dspinternal.h"
#include "xdsp.h"
#include <emmintrin.h>
#include "amaths.h"

//*XDSP*
static void SinApprox_V_V(float *pout, float const *pin, dword const n)
{
	for (dword i = 0; i < n; i++)
		pout[i] = sin(pin[i]);
}

//*XDSP*
static void CosApprox_V_V(float *pout, float const *pin, dword const n)
{
	for (dword i = 0; i < n; i++)
		pout[i] = cos(pin[i]);
}

//*XDSP*
static void TanApprox_V_V(float *pout, float const *pin, dword const n)
{
	for (dword i = 0; i < n; i++)
		pout[i] = tan(pin[i]);
}

//*XDSP*
static void AtanApprox_V_V(float *pout, float const *pin, dword const n)
{
	for (dword i = 0; i < n; i++)
		pout[i] = atan(pin[i]);
}

//*XDSP*
static void ExpApprox_V_V(float *pout, float const *pin, dword const n)
{
	for (dword i = 0; i < n; i++)
		pout[i] = exp(pin[i]);
}

//*XDSP*
static void Pow2Approx_V_V(float *pout, float const *pin, dword const n)
{
	xdsp.Pow2Approx2_V_V(pout, pin, n);
}

//*XDSP*
static void LogApprox_V_V(float *pout, float const *pin, dword const n)
{
	for (dword i = 0; i < n; i++)
		pout[i] = log(pin[i]);
}

//*XDSP*
static void Log2Approx_V_V(float *pout, float const *pin, dword const n)
{
	for (dword i = 0; i < n; i++)
		pout[i] = log2(pin[i]);
}


// hyperbolic


//*XDSP*
static void TanhApprox_V_V(float *pout, float const *pin, dword const n)
{
	for (dword i = 0; i < n; i++)
		pout[i] = tanh(pin[i]);
}

//*XDSP*
static void SinhApprox_V_V(float *pout, float const *pin, dword const n)
{
	for (dword i = 0; i < n; i++)
		pout[i] = 0.5f * (exp(pin[i]) - exp(-pin[i]));	// faster than sinh()
}

//*XDSP*
static void CoshApprox_V_V(float *pout, float const *pin, dword const n)
{
	for (dword i = 0; i < n; i++)
		pout[i] = 0.5f * (exp(pin[i]) + exp(-pin[i]));	// faster than cosh()
}

#include "set/TrigFPU.set"