#include "stdafx.h"
#include "dspinternal.h"


extern CXDSPInterface xdsp;


#pragma warning (disable : 4035)
static inline int highbit(int x) { __asm { bsr eax, [x] } }

//*XDSP*
static dword Compress_VS(byte *pout, short const *pin, dword const n, XLCAlgo const algo)
{
	int const maks = xdsp.AbsMax_VS(pin, n);
	if (maks == 0)
	{
		*pout = 0;
		return 8;
	}

	int const nb = highbit(maks) + 2;

	if (nb <= 8)
	{
		*pout++ = 1;
		for (dword i = 0; i < n; i++)
			*pout++ = (signed char)pin[i];

		return (n+1) * 8;
	}
	else
	{
		*pout++ = 2;
		short *ps = (short *)pout;
		memcpy(pout, pin, n * sizeof(short));

		return 8 + n * 16;
	}

}

//*XDSP*
static bool Decompress_VS(short *pout, byte const *pin, dword const n, dword const nbits, XLCAlgo const algo)
{
	byte const mode = *pin++;
	if (mode == 0)
	{
		memset(pout, 0, n * sizeof(short));
	}
	else if (mode == 1)
	{
		for (dword i = 0; i < n; i++)
			pout[i] = ((char *)pin)[i];
	}
	else if (mode == 2)
	{
		memcpy(pout, pin, n * sizeof(short));
	}
	else
	{
		return false;
	}

	return false;
}

//*XDSP*
static dword Compress_VI(byte *pout, int const *pin, dword const n, XLCAlgo const algo)
{
	int const maks = xdsp.AbsMax_VI(pin, n);
	if (maks == 0)
	{
		*pout = 0;
		return 8;
	}

	int const nb = highbit(maks) + 2;
	
	if (nb <= 8)
	{
		*pout++ = 1;
		for (dword i = 0; i < n; i++)
			*pout++ = (signed char)pin[i];

		return (n+1) * 8;
	}
	else if (nb <= 16)
	{
		*pout++ = 2;
		short *ps = (short *)pout;

		for (dword i = 0; i < n; i++)
			ps[i] = (short)pin[i];

		return 8 + n * 16;
	}
	else if (nb <= 24)
	{
		*pout++ = 3;
		byte *pinb = (byte *)pin;

		for (dword i = 0; i < n; i++)
		{
			pout[0] = pinb[0];
			pout[1] = pinb[1];
			pout[2] = pinb[2];
			pinb += 4;
			pout += 3;
		}
		
		
		return 8 + n * 24;
	}
	else
	{
		*pout++ = 4;
		int *pint = (int *)pout;
		memcpy(pint, pin, n * sizeof(int));
		return 8 + n * 32;
		
	}
	

	return 0;
}

//*XDSP*
static bool Decompress_VI(int *pout, byte const *pin, dword const n, dword const nbits, XLCAlgo const algo)
{
	byte const mode = *pin++;
	if (mode == 0)
	{
		memset(pout, 0, n * sizeof(int));
	}
	else if (mode == 1)
	{
		for (dword i = 0; i < n; i++)
			pout[i] = ((char *)pin)[i];
	}
	else if (mode == 2)
	{
		for (dword i = 0; i < n; i++)
			pout[i] = ((short *)pin)[i];
	}
	else if (mode == 3)
	{
		for (dword i = 0; i < n; i++)
		{
			pout[i] = ((pin[0] << 8) | (pin[1] << 16) | (pin[2] << 24)) >> 8;
			pin += 3;
		}
	}
	else if (mode == 4)
	{
		memcpy(pout, pin, n * sizeof(int));
	}
	else
	{
		return false;
	}
	
	return false;
}



#include "set/compress.set"