#include "stdafx.h"
#include "xdsp.h"
#include "dspinternal.h"

CXObject *CXSerializable::DeserializeObject(CStreamIn &si)
{
	int it;
	si.Read(it);
	CXObject::type const t = (CXObject::type)it;

	switch(t)
	{
	case CXObject::ResamplerFilter:
		return CXResamplerFilterImp::Deserialize(si);

	}

	
	return NULL;
}

void SetAll(CXDSPInterface *p, bool use_sse2, bool use_sse, bool use_mmx);


CXDSPInterface xdsp;
CXDSPInterface xdsp_noalign;


class CXDSPLib
{
public:
	CXDSPLib()
	{
		SetAll(&xdsp, true, true, true);
		SetAll(&xdsp_noalign, false, false, false);

		xdsp.Init(44100, (1.0 / (1 << 20)));
		xdsp_noalign.Init(44100, (1.0 / (1 << 20)));

	}

};

static CXDSPLib thelib;

void EnableSSE(bool enable)
{
	if (enable)
	{
		SetAll(&xdsp, true, true, true);
	}
	else
	{
		SetAll(&xdsp, false, false, false);
	}
	
}

